// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <tchar.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <string>
#include "SharedFileOut.h"


using namespace std;


template <typename T, unsigned S>
inline unsigned arraysize(const T(&v)[S])
{
	return S;
}


struct SMElement
{
	HANDLE hMapFile;
	unsigned char* mapFileBuffer;
};

SMElement m_graphics;
SMElement m_physics;
SMElement m_static;

void initPhysics()
{
	TCHAR szName[] = TEXT("Local\\acpmf_physics");
	m_physics.hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(SPageFilePhysics), szName);
	if (!m_physics.hMapFile)
	{
		MessageBoxA(GetActiveWindow(), "CreateFileMapping failed", "ACS", MB_OK);
	}
	m_physics.mapFileBuffer = (unsigned char*)MapViewOfFile(m_physics.hMapFile, FILE_MAP_READ, 0, 0, sizeof(SPageFilePhysics));
	if (!m_physics.mapFileBuffer)
	{
		MessageBoxA(GetActiveWindow(), "MapViewOfFile failed", "ACS", MB_OK);
	}
}

void initGraphics()
{
	TCHAR szName[] = TEXT("Local\\acpmf_graphics");
	m_graphics.hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(SPageFileGraphic), szName);
	if (!m_graphics.hMapFile)
	{
		MessageBoxA(GetActiveWindow(), "CreateFileMapping failed", "ACS", MB_OK);
	}
	m_graphics.mapFileBuffer = (unsigned char*)MapViewOfFile(m_graphics.hMapFile, FILE_MAP_READ, 0, 0, sizeof(SPageFileGraphic));
	if (!m_graphics.mapFileBuffer)
	{
		MessageBoxA(GetActiveWindow(), "MapViewOfFile failed", "ACS", MB_OK);
	}
}

void initStatic()
{
	TCHAR szName[] = TEXT("Local\\acpmf_static");
	m_static.hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(SPageFileStatic), szName);
	if (!m_static.hMapFile)
	{
		MessageBoxA(GetActiveWindow(), "CreateFileMapping failed", "ACS", MB_OK);
	}
	m_static.mapFileBuffer = (unsigned char*)MapViewOfFile(m_static.hMapFile, FILE_MAP_READ, 0, 0, sizeof(SPageFileStatic));
	if (!m_static.mapFileBuffer)
	{
		MessageBoxA(GetActiveWindow(), "MapViewOfFile failed", "ACS", MB_OK);
	}
}

void dismiss(SMElement element)
{
	UnmapViewOfFile(element.mapFileBuffer);
	CloseHandle(element.hMapFile);
}

void printData(string name, float value)
{
	wcout << name.c_str() << " : " << value << endl;
}

template <typename T, unsigned S>
inline void printData(const string name, const T(&v)[S])
{
	wcout << name.c_str() << " : ";
	for (int i = 0; i < S; i++)
	{
		wcout << v[i];
		if (i < S - 1)
		{
			wcout << " , ";
		}
	}
	wcout << endl;
}

const string currentDateTime() {
    time_t now = time(0); // ð time_t Ÿ 
    struct tm tstruct;
    char buf[80];
    localtime_s(&tstruct,&now);
    strftime(buf, sizeof(buf), "%Y%m%d_%H%M%S", &tstruct); // YYYYmmdd_HHMMSS  Ʈ

    return buf;
}



ofstream fLog;
ofstream fOut;

int _tmain(int argc, _TCHAR* argv[])
{
	string path1 = "D:/FileIO/DB/AC_Telemetry_";
	string path2 = ".txt";
	string rtPath = "D:/FileIO/DB/AC_TELE_REALTIME.csv";

	cout << "please press password" << endl;
	// 0714  Ʒ while  Ѿ
	while (GetAsyncKeyState(0x30) == 0){} //  0  
	while (GetAsyncKeyState(0x37) == 0){} //  7  
	while (GetAsyncKeyState(0x31) == 0){} //  1  
	while (GetAsyncKeyState(0x34) == 0){} //  4  
	cout << "password correct!" << endl;


	fLog.open(path1 + currentDateTime() + path2);
	fLog << "AccX\tAccY\tAccZ\tVelX\tVelY\tVelZ\tHeading\tRoll\tPitch\tSpeed" << endl;

	initPhysics();
	//initGraphics();
	//initStatic();

	while (true)
	{
		float acc[3];
		SPageFilePhysics* pf = (SPageFilePhysics*)m_physics.mapFileBuffer;

		for(int i=0;i<3;i++)
			acc[i] = pf->accG[i];

		// ǿ  Ϸ 
		if(acc[0]+acc[1]+acc[2] != 0){ //  ÿ
			fLog << pf->accG[0];
			fLog << '\t';
			fLog << pf->accG[1];
			fLog << '\t';
			fLog << pf->accG[2];
			fLog << '\t';
			fLog << pf->velocity[0];
			fLog << '\t';
			fLog << pf->velocity[1];
			fLog << '\t';
			fLog << pf->velocity[2];
			fLog << '\t';
			fLog << pf->heading;
			fLog << '\t';
			fLog << pf->roll;
			fLog << '\t';
			fLog << pf->pitch;
			fLog << '\t';
			fLog << pf->speedKmh;
			fLog << endl;
		}
		fOut.open(rtPath);
		fOut << pf->accG[0];
		fOut << ',';
		fOut << pf->accG[2];
		fOut << endl;
		fOut.close();

		if (GetAsyncKeyState(0x43) & 0x8000){ // c 
			cout << " Log ended & New file created" << endl;

			fOut.open(rtPath);
			fOut << '0,0' << endl;
			fOut.close();

			fLog.close(); //  α ϰ
			fLog.open(path1 + currentDateTime() + path2); //  α 
			fLog << "AccX\tAccY\tAccZ\tVelX\tVelY\tVelZ\tHeading\tPitch\tRoll\tSpeed" << endl;
			Sleep(500);
		}

		if(GetAsyncKeyState(0x51) & 0x8000){ // q 
			cout << "Program Finished" << endl;

			fOut.open(rtPath);
			fOut << '0,0' << endl;
			fOut.close();
			
			fLog.close();
			break; // α׷ 
		}
		
		Sleep(100);
	}

	dismiss(m_physics);
	//dismiss(m_graphics);
	//dismiss(m_static);
	
	return 0;
}


